import { TypedEvent } from './TypedEvent';
var CancelationTokenSource = (function () {
    function CancelationTokenSource() {
        this._canceled = false;
        this._cancellationRequested = false;
        this.CancellationEvent = new TypedEvent();
    }
    CancelationTokenSource.prototype.Cancel = function () {
        if (this._cancellationRequested)
            throw Error("Cancelation has already been requested.");
        this._cancellationRequested = true;
        this.CancellationEvent.Invoke();
        this._canceled = true;
    };
    Object.defineProperty(CancelationTokenSource.prototype, "IsCancelled", {
        get: function () {
            return this._canceled;
        },
        enumerable: false,
        configurable: true
    });
    return CancelationTokenSource;
}());
export { CancelationTokenSource };
//# sourceMappingURL=CancelationTokenSource.js.map