import { ITypedEvent } from '../../TypedEvent';
import { FieldChangeResult } from '../FieldChangeResult';
import { CommunicationWay, DeviceResponseType, DeviceState, DeviceTaskType, DeviceType, IDevice } from './IDevice';
import { IDeviceChannel } from './IDeviceChannel';
import { IDeviceState } from './IDeviceState';
import { IDeviceTask } from './IDeviceTask';
import { DeviceTaskExecutionResult } from './TaskExecutionResult';
export declare class Device implements IDevice {
    OnDeviceStateChangedEvent(): ITypedEvent<IDeviceState>;
    get SerialNumber(): string;
    get ModelGuid(): string;
    get ManufacturerGuid(): string;
    get IsVirtual(): boolean;
    get IsEnabled(): boolean;
    get DeviceState(): DeviceState;
    get DeviceType(): DeviceType;
    get CommunicationWay(): CommunicationWay;
    get AvailableTasks(): string[];
    get AvailableTaskTypes(): DeviceTaskType[];
    get AvailableResponseTypes(): DeviceResponseType[];
    get Channels(): IDeviceChannel[];
    ChangeDeviceNameAsync(name: string): Promise<FieldChangeResult>;
    ExecuteTaskAsync(task: IDeviceTask, channel: number): Promise<DeviceTaskExecutionResult>;
    private _guid?;
    private _name?;
    private _channelsAmount?;
    get Guid(): string;
    set Guid(guid: string);
    get Name(): string;
    set Name(name: string);
    get ChannelsAmount(): number;
    set ChannelsAmount(amount: number);
}
