import { IDIService } from '../../IDIService';
import { ITypedEvent } from '../../TypedEvent';
import { IDevice } from './IDevice';
import { IDevicesService } from './IDevicesService';
import { IDeviceState } from './IDeviceState';
export declare class DevicesService implements IDIService, IDevicesService {
    private _serviceName;
    private _onDeviceFoundEvent;
    private _onDeviceRegisteredEvent;
    private _onDeviceRemovedEvent;
    private _onDeviceStateChangedEvent;
    GetServiceName(): string;
    SyncDevicesStatesAsync(): Promise<IDeviceState[]>;
    OnDeviceStateChangedEvent(): ITypedEvent<[Device: IDevice, State: IDeviceState]>;
    OnDeviceRegisteredEvent(): ITypedEvent<IDevice>;
    OnDeviceRemovedEvent(): ITypedEvent<IDevice>;
    OnDeviceFoundEvent(): ITypedEvent<IDevice>;
    GetDevicesAsync(): Promise<IDevice[]>;
    GetDevice(guid: string): Promise<IDevice>;
    FindDevicesAsync(device: IDevice): Promise<void>;
    RegisterDeviceAsync(device: IDevice): Promise<void>;
    RemoveDeviceAsync(device: IDevice): Promise<void>;
}
