var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { nameof } from "ts-simple-nameof";
import { Api } from "../../Api";
import { ExalusConnectionService } from "../../ExalusConnectionService";
import { TypedEvent } from "../../TypedEvent";
import { AccessLevel, Gender } from '../Users/IUser';
import { LoginError } from "./ISessionService";
import { DataFrame, Method, Status } from '../../DataFrame';
import { DependencyContainer } from "../../DependencyContainer";
import { User } from "../Users/User";
var SessionService = (function () {
    function SessionService() {
        this._onUserLoggedInEvent = new TypedEvent();
        this._onUserLoggedOutEvent = new TypedEvent();
        this._serviceName = nameof(SessionService);
        this._user = null;
    }
    SessionService.prototype.OnUserLoggedInEvent = function () {
        return this._onUserLoggedInEvent;
    };
    SessionService.prototype.OnUserLoggedOutEvent = function () {
        return this._onUserLoggedOutEvent;
    };
    Object.defineProperty(SessionService.prototype, "User", {
        get: function () {
            return this._user;
        },
        enumerable: false,
        configurable: true
    });
    SessionService.prototype.UserLogOutAsync = function () {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            var logoutRequest, result;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        logoutRequest = new DataFrame();
                        logoutRequest.Resource = "/users/user/logout";
                        logoutRequest.Method = Method.Put;
                        return [4, Api.Get(ExalusConnectionService)
                                .SendAndWaitForResponseAsync(logoutRequest, 5000, false)];
                    case 1:
                        result = _c.sent();
                        if (result.Status == Status.OK) {
                            this._onUserLoggedOutEvent.Invoke(this._user);
                            (_a = DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Debug("User has been logged out.");
                        }
                        else
                            (_b = DependencyContainer.Log) === null || _b === void 0 ? void 0 : _b.Debug("Failed to logout user!");
                        return [2];
                }
            });
        });
    };
    SessionService.prototype.UserLogInAsync = function (email, password) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function () {
            var connection, result, user;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        connection = Api.Get(ExalusConnectionService);
                        return [4, connection.SendAndWaitForResponseAsync(new LoginUserRequest(email, password), 5000, false)];
                    case 1:
                        result = _c.sent();
                        (_a = DependencyContainer.Log) === null || _a === void 0 ? void 0 : _a.Debug("Did logging in succeded?: ".concat(result.Status == Status.OK));
                        if (result.Status == Status.OK && result.Data != null) {
                            user = new User();
                            this._user = user;
                            user.AccessLevel = result.Data.AccessLevel;
                            user.Email = result.Data.Email;
                            user.Gender = result.Data.Gender;
                            user.Guid = result.Data.Guid;
                            user.IsAccountOnline = result.Data.IsAccountOnline;
                            user.Name = result.Data.Name;
                            user.IsActive = result.Data.IsActive;
                            user.IsBanned = result.Data.IsBanned;
                            user.Phone = result.Data.Phone;
                            user.Surname = result.Data.Surname;
                            this._onUserLoggedInEvent.Invoke(this._user);
                            return [2, user];
                        }
                        else {
                            (_b = DependencyContainer.Log) === null || _b === void 0 ? void 0 : _b.Debug("User login response: ".concat(result.Data));
                            return [2, LoginError.WrongAuthData];
                        }
                        return [2];
                }
            });
        });
    };
    SessionService.prototype.GetServiceName = function () {
        return this._serviceName;
    };
    return SessionService;
}());
export { SessionService };
var UserData = (function () {
    function UserData() {
        this.Guid = "";
        this.Name = "";
        this.Surname = "";
        this.Password = "";
        this.Email = "";
        this.Phone = "";
        this.IsActive = true;
        this.IsBanned = false;
        this.IsAccountOnline = false;
        this.AccessLevel = AccessLevel.Any;
        this.Gender = Gender.Unknown;
        this.ConfigurationTime = "";
        this.IsGeolocationSet = false;
        this.UpdatesChannel = "";
    }
    return UserData;
}());
export { UserData };
var UserLoginData = (function () {
    function UserLoginData(email, password) {
        this.Email = "";
        this.Password = "";
        this.Email = email;
        this.Password = password;
    }
    return UserLoginData;
}());
var LoginUserRequest = (function (_super) {
    __extends(LoginUserRequest, _super);
    function LoginUserRequest(email, password) {
        var _this = _super.call(this) || this;
        _this.Data = new UserLoginData(email, password);
        _this.Resource = "/users/user/login";
        _this.Method = Method.Put;
        return _this;
    }
    return LoginUserRequest;
}(DataFrame));
//# sourceMappingURL=SessionService.js.map