import { Api } from '../../Api';
import { LocalStorageService } from '../LocalStorageService';
import { nameof } from 'ts-simple-nameof';
import { LoggerService } from '../Logging/LoggerService';
var WebApiCacheService = (function () {
    function WebApiCacheService() {
        this._log = Api.Get(LoggerService);
        this._serviceName = nameof(LocalStorageService);
        WebApiCacheService._localStorageService = Api.Get(LocalStorageService);
    }
    WebApiCacheService.prototype.GetServiceName = function () {
        return this._serviceName;
    };
    WebApiCacheService.prototype.GetResourceName = function (data) {
        return "".concat(data.Resource, "_").concat(data.Method);
    };
    WebApiCacheService.prototype.Cache = function (data) {
        var _a;
        var tmp = JSON.stringify(data);
        this._log.Debug("Caching request: ".concat(data.Resource, " ").concat(data.Method, "\n").concat(tmp));
        (_a = WebApiCacheService._localStorageService) === null || _a === void 0 ? void 0 : _a.Save(WebApiCacheService, this.GetResourceName(data), tmp);
    };
    WebApiCacheService.prototype.GetCache = function (data) {
        var _a;
        var tmp = (_a = WebApiCacheService._localStorageService) === null || _a === void 0 ? void 0 : _a.Read(WebApiCacheService, this.GetResourceName(data));
        if (tmp == null)
            this._log.Debug("Got request response from cache: ".concat(data.Resource, " ").concat(data.Method, "\n").concat(tmp));
        return tmp;
    };
    WebApiCacheService.prototype.ClearCache = function () {
        var _a;
        (_a = WebApiCacheService._localStorageService) === null || _a === void 0 ? void 0 : _a.DropStorage(WebApiCacheService);
        this._log.Debug("Clearing cache for ".concat(this.GetServiceName()));
    };
    WebApiCacheService.prototype.Remove = function (data) {
        var _a;
        (_a = WebApiCacheService._localStorageService) === null || _a === void 0 ? void 0 : _a.Remove(WebApiCacheService, this.GetResourceName(data));
        this._log.Debug("Clearing cache for cache: ".concat(data.Resource, " ").concat(data.Method));
    };
    WebApiCacheService._localStorageService = null;
    return WebApiCacheService;
}());
export { WebApiCacheService };
//# sourceMappingURL=WebApiCacheService.js.map